; Soft pro WXRX

      POMOC bit 1
      SAMPLE   bit  P3.7
      KOMP     bit  P3.0
      HFRH    DATA 31H        ;hex hodnota pro SAA
     HFRL    DATA 30H         ; -''-  low
     PWORTH  equ 31h          ;vstup
     PWORTL  equ 30h          ;vstup
     CLB  bit  P3.5      ;synchr. vodic SAA
     SDATA   bit  P3.3        ;datovy    -''-
     DLEN    bit  P3.4        ;prenos
      FREQ    DATA  33h               ; pocitadlo kmitoctu
      TABKMI  equ  200h              ;zacatek tabulky
      DISP    DATA  34h
     DICLOCK bit P3.4              ;hodiny pro displ
     DIDATA  bit P3.3             ; data pro displej
     B3_R4   DATA  1Ch        ;registr R4 banky 3
     B3_R3   DATA 1Bh         ;    
     B3_R2   DATA  1Ah        ;
     B3_R1   DATA  19h        ;


       org 00h

       JMP     GO         ;zacatek

       org 03h
     clr EA
       call OBSLUH                  ;INT0
       reti

  org 10h

GO:     mov HFRH,#0c1h             ;ridici slovo pro syntezu
        mov HFRL,#05h
	call ONESK
	call ONESK
	call ONESK		; cekej po zapnuti na RX

        call SAA1057               ;posle do syntezy
        mov FREQ,#00                    ; prvni kmitocet
        call NACTI                      ;nacti z mem a posli

        CLR      EA                  ;zacatek, zakaze INT
        MOV      SP,#43H
        MOV      P1,#0FFH            ; inic portu
        MOV      TCON,#00H         ;TIM0 jako 8bit,samoplneni
        MOV      TMOD,#21H         ;TIM1 jako 16bit
        MOV      3DH,#22H
        MOV      3CH,#0FFH
        MOV      TH0,#22H          ;
        MOV      TL0,#22H
        MOV      IE,#00H      ;zakaze vsechna INT
        MOV      IP,#00H
        MOV      TH1,#0FFH         ;prenosova rychlost
        MOV      TL1,#0FFH
        MOV      PCON,#80H
        MOV      SCON,#00H         ;dvojnasobna pren. rychlost
        SETB     SM1               ;<--'
        CLR      RI           ; priznak RXu
        SETB     TR1               ; spust TR1
        CLR      RS0               ; nastaveni banky reg.
        CLR      RS1
        SETB     EA           ; povoli INT globalne
        SETB     TI
        setb     EX0                    ; povoli int0

PREVOD: MOV      P1,#80H                ; P1.7 do H
;        CLR      SAMPLE                ; HOLD (puvodne setb)
        LCALL    ZPOZ            ; zpozdeni
        JNB      KOMP,N1            ; merene U je vetsi nez
                                  ; z DA? skoc!
        MOV      P1,#40H            ; P1.6 do H, sniz Uda
        LCALL    ZPOZ
        JNB      KOMP,N2            ; uz je U > Uda
Z1:     CLR      P1.6            ; jeste je U < Uda
        SETB     P1.5
        LCALL    ZPOZ
        JNB      KOMP,N3
Z2:     CLR      P1.5
        SETB     P1.4
        LCALL    ZPOZ
        JNB      KOMP,N4
Z3:     CLR      P1.4
        SETB     P1.3
        LCALL    ZPOZ
        JNB      KOMP,N5
Z4:     CLR      P1.3
        SETB     P1.2
        LCALL    ZPOZ
        JNB      KOMP,N6
Z5:     CLR      P1.2
        SETB     P1.1
        LCALL    ZPOZ
        JNB      KOMP,N7
Z6:     CLR      P1.1
        SETB     P1.0
        LCALL    ZPOZ
        JNB      KOMP,N8            ;
        LJMP     N9            ; stale U<Uda
N1:     SETB     P1.6            ; zacina s bitem P1.6
        LCALL    ZPOZ
        JB       KOMP,Z1
N2:     SETB     P1.5
        LCALL    ZPOZ
        JB       KOMP,Z2
N3:     SETB     P1.4
        LCALL    ZPOZ
        JB       KOMP,Z3
N4:     SETB     P1.3
        LCALL    ZPOZ
        JB       KOMP,Z4
N5:     SETB     P1.2
        LCALL    ZPOZ
        JB       KOMP,Z5
N6:     SETB     P1.1
        LCALL    ZPOZ
        JB       KOMP,Z6
N7:     SETB     P1.0
        LCALL    ZPOZ
        JB       KOMP,N9
        LJMP     N8
N9:     CLR      P1.0            ; mensi nez nejnizsi bit
N8:     SETB      SAMPLE            ; SAMPLE (puvodne CLR)
       nop
       nop
        nop
       clr SAMPLE             ;4us impluls
       JNB TI,$
        MOV      A,P1            ; hodnota po prevodu
        CLR      TI
        MOV      SBUF,A            ; a ted ji vysle na RSku
        LJMP     PREVOD            ; a prevadi se znovu

ZPOZ:   MOV      R7,#02H            ;cekaci smycka
        DJNZ     R7,$
        RET                        ;konec



;*********************************************************
;PROGRAM PRO VYSLANI 16 BITU DO SAA1057 PO SBERNICI C-BUS
;*********************************************************

SAA1057:            ;umlcovaci vystup
     clr CLB
     clr SDATA
     clr DLEN
     setb DLEN           ;zacatek prenosu
     mov R2,#02h
     mov R0,#32h
     call SCLOCK
PULE:     dec R0
     mov A,@R0
     mov R3,#08h
KROK:     clr SDATA
     rlc A
     jnc NULA
     setb SDATA
NULA:     call SCLOCK
     djnz R3,KROK
     djnz R2,PULE
     clr DLEN            ;konec prenosu
     clr SDATA
SCLOCK: setb CLB              ;impuls 6 us
     nop
     nop
     nop
     nop
     nop
     nop
     clr CLB
     ret


;*********************************
;Nacte z pameti kod SAA a DISP
;a posle je.
;*********************************


NACTI:  mov R0,#1Eh           ; registr R6 banky 3
       mov R7,#07             ; nacte se 7 byte
	mov A,FREQ
        mov DPTR,#TABKMI               ; zacatek dat v pameti
CTIDAL: movc A,@A+DPTR                  ; najdi data
       mov @R0,A                   ; uloz do spravne bunky
       dec R0
       mov A,FREQ
       inc ACC
       mov FREQ,A
       djnz R7,CTIDAL              ; nacti zbytek       

       mov HFRL,1Eh			; nacte HFRL z R6
       mov HFRH,1Dh			; nacte HFRH z R5
       call SAA1057                    ; posle kmitocet
       clr SDATA
       mov R0,#35d		; jeste 35 implusu
ZHASNI:setb DLEN			
       nop
       nop
       nop
       nop
       nop
       nop
       clr DLEN
       nop
       nop
       nop
       nop
       nop
       nop
       djnz R0,ZHASNI		; a zhasne vsechno
       call DISPLEJ           ; posle data na displej  
       ret

OBSLUH: push 224
	push 07
	mov A,FREQ
       cjne A,#2ah,FINE            ; preteceni
       mov A,#00h            ; po pricteni 7 da 0
       mov FREQ,A		;uloz
FINE:   call NACTI                      ; nacte a posle
       call ONESK             ; zpozdeni
	jnb P3.2,$
	call ONESK
       setb EA
	pop 07
	pop 224
        ret


ONESK:mov R3,#00
RV:  mov R4,#00
     djnz R4,$
     djnz R3,RV
     ret


;**********************************************************
;               VYSLE DATA NA DISPLEJ
;**********************************************************

     
        
DISPLEJ: clr POMOC
     	clr DIDATA
     	clr DICLOCK
     	setb DIDATA              ;startovaci puls
     	call DCLOCK
     	mov R0,#1Ch              ;R4/B3
     	mov R2,#04h              ;pocet registru pro prenos
REGIST:   mov R1,#08h
POSLED:   mov A,@R0
BITY:     clr DIDATA               ;data do LOW
     rlc A
     jnc SEM
     setb DIDATA
SEM: call DCLOCK
     djnz R1,BITY
     dec R0                   ;dalsi reg
     djnz R2,REGIST
                         ;konec prenosu 4 registru
     jb POMOC,KONEC
     mov R2,#01h              ;jiz jen jeden registr, R0_B3
     mov R1,#03h              ;jen 3 bity
     setb POMOC
     jmp POSLED
DCLOCK:   setb DICLOCK             ;vytvori synchr.impuls
        nop
        nop
        nop
        nop
        nop
          clr DICLOCK
     nop
     nop
     nop
     nop
     ret

KONEC: clr DIDATA
       ret




org TABKMI

    db     88h          ;137.5
    db     31h
    db     63h
    db     0ech
    db     0ddh
    db     9fh
    db     20h
    db     0e6h          ;141
    db     32h          
    db     63h
    db     0fch
    db     0ceh
    db     8bh
    db     0a0h
    db     94h          ;137.62
    db     31h
    db     61h
    db     0fch
    db     0ddh
    db     9fh
    db     040h
    db     0ABh         ;137.85
    db     31h
    db     23h
    db     7ch
    db     0ddh
    db     9fh
    db     0e0h
    db     74h          ;137.3
    db     31h
    db     63h
    db     0ech
    db     0ddh
    db     9dh
    db     0a0h
    db     7Eh          ;137.4
    db     31h  
    db     63h
    db     0cch
    db     0ddh
    db     9eh
    db     0a0h

end

